/*
 * $Id: errorlog.h,v 1.1.1.1 1996/06/30 15:50:54 mtp Exp $
 ****************************************************************************
 *    
 *  COPYRIGHT NOTICE
 *    
 *  Copyright (C) 1995, 1996 Michael T. Peterson
 *  This file is part of the PCthreads (tm) multithreading library
 *  package.
 *    
 *  The source files and libraries constituting the PCthreads (tm) package
 *  are free software; you can redistribute them and/or modify them under
 *  the terms of the GNU Library General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *    
 *  The PCthreads (tm) package is distributed in the hope that it will
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *    
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library (see the file COPYING.LIB); if not,
 *  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
 *  MA 02139, USA.
 *    
 *  To report bugs, bug fixes, or provide feedback you may contact the
 *  author, Michael T. Peterson, at either of the two email addresses listed
 *  below:
 *    
 *             mtp@big.aa.net (preferred)
 *             mtp@zso.dec.com
 *    
 *    
 *  Michael T. Peterson
 *  Issaquah, WA
 *  29 January, 1996
 ****************************************************************************
 * $Log: errorlog.h,v $
 * Revision 1.1.1.1  1996/06/30 15:50:54  mtp
 * DCE threads for Linux V1.0
 *
 ****************************************************************************
 */
#ifndef _errorlog_
#define _errorlog_
#include <errno.h>
#include <stdarg.h>

#define ERRLOG_C_STRLEN ((size_t) 1024)

/* 
 * Initialize the syslog() facility
 */
extern void
log_open( const char *ident, int option, int facility );

/*
 * Nonfatal error related to a system call. Print a message with the 
 * system's errno value and return.
 */
void
log_ret(const char *fmt, ...);

/* 
 * Fatal error related to a system call.  Print a message and terminate.
 */
extern void
log_sys(const char *fmt, ...);

/* 
 * Nonfatal error unrelated to a system call. Print a message and return.
 */
void
log_msg(const char *fmt, ...);

/* 
 * Fatal error unrelated to a system call.  Print a message and terminate.
 */
extern void
log_quit(const char *fmt, ...);

#endif
