#ifndef lint
static const char rcsid[] = "$Id: test2.c,v 1.1.1.1 1996/06/30 15:50:54 mtp Exp $";
#endif
/****************************************************************************
 *    
 *  COPYRIGHT NOTICE
 *    
 *  Copyright (C) 1995, 1996 Michael T. Peterson
 *  This file is part of the PCthreads (tm) multithreading library
 *  package.
 *    
 *  The source files and libraries constituting the PCthreads (tm) package
 *  are free software; you can redistribute them and/or modify them under
 *  the terms of the GNU Library General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *    
 *  The PCthreads (tm) package is distributed in the hope that it will
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *    
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library (see the file COPYING.LIB); if not,
 *  write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
 *  MA 02139, USA.
 *    
 *  To report bugs, bug fixes, or provide feedback you may contact the
 *  author, Michael T. Peterson, at either of the two email addresses listed
 *  below:
 *    
 *             mtp@big.aa.net (preferred)
 *             mtp@zso.dec.com
 *    
 *    
 *  Michael T. Peterson
 *  Issaquah, WA
 *  29 January, 1996
 ****************************************************************************
 * $Log: test2.c,v $
 * Revision 1.1.1.1  1996/06/30 15:50:54  mtp
 * DCE threads for Linux V1.0
 *
 ****************************************************************************
 */
#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <signal.h>
#include <utils.h>

#define ITERATIONS (1000000)
#define THREADS (1)

static void 
proc( struct timeval *tv )
{
   long i, sum = 0;
   
   for(i = 0; i < ITERATIONS; i++)
       sum += 1;

   i = 0;
   while( --sum >= 0 )
       i += 1;

   pthread_exit( (void *) SUCCESS );
}

static pthread_t  *th;
static pthread_attr_t attr;
   
int 
main( int argc, char *argv[] )
{
   int thread_count = THREADS, i, exit_status;
   struct sched_param param = { SCHED_ROUND_ROBIN_C,
                                PRI_RR_DEFAULT,
                                1                    /* A single quantum */
                              };

   if( argc == 2 )
       thread_count = atoi( argv[1] );

   (void) pthread_attr_init( &attr );
   (void) pthread_attr_setdetachstate( &attr, PTHREAD_CREATE_JOINABLE );
   (void) pthread_attr_setschedparam( &attr, &param );

   (void) pthread_setprio_np( pthread_self(), PRI_RR_MAX );
   th = malloc( thread_count * sizeof( pthread_t * ) );

   for(i = 0; i < thread_count; i++ )
       (void) pthread_create( &th[i], &attr, (thread_proc_t) proc, NULL );

   for(i = 0; i < thread_count; i++ )
   {
       (void) pthread_join( th[i], (void **) &exit_status );
       if( exit_status != SUCCESS )
           fprintf(stderr, "Failed to join with th[%d]!\n", i);
   }

   free( th );
   (void) pthread_attr_destroy( &attr );

   print_system_counters();
   return( EXIT_SUCCESS );
}
